#include <piece.h>
#include <string.h>
#include <muslib.h>
#include "mus_com.h"

// 
void initialize(void){
  InitMusic();

  pceFontSetPos(4, 4);
  pceFontPrintf("MUSIC COMMANDER %s", MUS_COM_VERSION);

  pceLCDPaint(3, 48, 22, 33, 13);
  pceLCDPaint(0, 49, 23, 31, 11);

  pceFontSetPos(14, 44);
  pceFontPrintf("def@@@@@");
  pceFontSetPos(14, 54);
  pceFontPrintf("c@`");
  pceFontSetPos(14, 64);
  pceFontPrintf("b@a@@@@");
}

// t
void play(void){
  static unsigned long padOld = 0;
  int octave, sharp;
  TONE *tone;

  // pbhԂςȂΉtԂ̂܂
  if((pad & PAD_ANY) == padOld){
    return;
  }
  padOld = pad & PAD_ANY;

  // pbhԂς牉tU~
  StopMusic();

/*
  // `{a{X^[g{ZNgŃj[
  if((pad & PAD_A) && (pad & PAD_B) && (pad & PAD_C) && (pad & PAD_D)){
  }
*/

  pceFontSetPos(49, 24);
  pceFontPrintf("@@@");
  pceFontSetPos(14, 44);
  pceFontPrintf("def@@@@@");
  pceFontSetPos(14, 54);
  pceFontPrintf("c@`");
  pceFontSetPos(14, 64);
  pceFontPrintf("b@a@@@@");
  draw = TRUE;

  pceFontSetTxColor(0);
  pceFontSetBkColor(3);

  // IN^[uݒ
  octave =  0;
  if(pad & PAD_B){
    octave = -1;
    pceFontSetPos(94, 64);
    pceFontPrintf("");
  }
  if(pad & PAD_A){
    octave = +1;
    pceFontSetPos(104, 44);
    pceFontPrintf("");
  }

  // V[vEtbgݒ
  sharp =  0;
  if(pad & PAD_D){
    sharp = -1;
    pceFontSetPos(64, 64);
    pceFontPrintf("");
  }
  if(pad & PAD_C){
    sharp = +1;
    pceFontSetPos(74, 44);
    pceFontPrintf("");
  }

  switch(pad & (PAD_UP | PAD_DN | PAD_LF | PAD_RI)){

    // @h@@b
    case PAD_LF | PAD_DN:
      tone = &c;
      pceFontSetPos(14, 64);
      pceFontPrintf("b");
      break;

    // @@@@c
    case PAD_LF:
      tone = &d;
      pceFontSetPos(14, 54);
      pceFontPrintf("c");
      break;

    // @~@@d
    case PAD_LF | PAD_UP:
      tone = &e;
      pceFontSetPos(14, 44);
      pceFontPrintf("d");
      break;

    // @@t@@e
    case PAD_UP:
      tone = &f;
      pceFontSetPos(24, 44);
      pceFontPrintf("e");
      break;

    // E@\@@f
    case PAD_RI | PAD_UP:
      tone = &g;
      pceFontSetPos(34, 44);
      pceFontPrintf("f");
      break;

    // E@@@@`
    case PAD_RI:
      tone = &a;
      pceFontSetPos(34, 54);
      pceFontPrintf("`");
      break;

    // E@V@@a
    case PAD_RI | PAD_DN:
      tone = &b;
      pceFontSetPos(34, 64);
      pceFontPrintf("a");
      break;

    // 
    default:
      pceFontSetTxColor(3);
      pceFontSetBkColor(0);
      return;
  }

  pceFontSetTxColor(3);
  pceFontSetBkColor(0);
  pceFontSetPos(49, 24);

  // IN^[u\
  if(octave == +1){
    pceFontPrintf("");
  }
  else if(octave == -1){
    pceFontPrintf("");
  }
  else{
    pceFontPrintf("@");
  }

  // \
  pceFontPrintf("%s", tone->name);

  // V[vEtbg\A
  if((sharp == +1) && tone->sharp){
    pceFontPrintf("");
  }
  else if((sharp == -1) && tone->flat){
    pceFontPrintf("");
  }
  else{
    sharp = 0;
  }

  // t
  pmd[0x1c] = 12 * octave + tone->code + sharp;
  PlayMusic(pmd);
}
